import itertools, re
from Esercizio1.MyStrIter import myStrIter

class myStr (str):
  
  def __init__ (self, string):
    str.__init__(string)
    
  # Metodo che verifica il palindromo in maniera iterativa  
  def iter_palindrome (self):
    print ('La stringa "{0}"'.format (self))
    self.new_string = self.subtraction('?!\'".:;,(){}[] ')
    self.palindrome = myStrIter (self.new_string)
    for i in self.palindrome:
      if i != None:
        print (i)
    
  # Metodo che verifica il palindromo in maniera sequenziale
  def is_palindrome (self):
    
    self.new_string = self.subtraction('?!\'".:;,(){}[] ')
    
    self.palindrome = self.new_string [::-1]
    if self.palindrome.lower() == self.new_string.lower():
      return 'La stringa "{0}" è palindroma'. format (self)
    else:
      return 'La stringa "{0}" non è palindroma'. format (self)
  
  # Metodo che toglie da una stringa data una quantità di caratteri
  def subtraction (self, string):
    
    self.mask = []
    for k in range (len (self)):
      self.mask.append (1)
    self.new_string = ''
    
    for i in range (len (string)):
      for j in range (len (self)):
        if self.mask[j] != 0:
          if string[i] == self[j]:
            del self.mask[j]
            self.mask.insert (j, 0)
          else:
            del self.mask[j]
            self.mask.insert (j, 1)
             
    for elem in itertools.compress (self, self.mask):
      self.new_string += elem    
      
    return self.new_string
    
  # Metodo che trova gli anagrammi di una stringa in un dizionario dato
  def is_anagram (self, dic):
    pattern = re.compile ('['+self.lower()+']')
    print ('Nel dizionario fornito abbiamo trovato \ni seguenti anagrammi della parola "{0}":'.format (self))
    
    for elem in itertools.permutations (self.lower()):
      for i in range (len (dic)):
        if re.findall (pattern, dic[i].lower()) == list (elem):
          print (dic[i])

  
  def __str__(self):
    return self