from Esercizio2.Node import node
from Esercizio2.Link import link

from Esercizio2.IterVisit import iterVisit

class socialGraph ():
  
  lista_nodi = []
  lista_relazioni = []
  
  def __init__ (self, lista):
    self.lista_nodi = lista
    self.num_nodi = len (lista)
    self.num_relazioni = len (self.lista_relazioni)
    
  # Metodo che definisce la relazione tra i nodi
  def relazione_nodi (self, lista_nodi, tipo_relazione):
    self.relazione = link (lista_nodi, tipo_relazione)
    self.lista_relazioni.append(self.relazione)
    self.num_relazioni = len (self.lista_relazioni)
  
  # Metodo che visita tutto il social
  def visita_social (self):
    for nodo in self.lista_nodi:
      print (nodo)
    for relazione in self.lista_relazioni:
      print (relazione)
  
  # Metodo che visita tutti il social in maniera iterativA
  def visita_iterativa_social (self):
    self.grafo_visitato = {}
    self.visit = iterVisit (self.lista_nodi, self.lista_relazioni)
    
    for i in self.visit:
      print (i)
    
    for k in range (len (self.visit.lista_gruppi)):
      self.grafo_visitato[self.visit.lista_gruppi[k]] = self.visit.lista_relazioni[k]
      
    print ('Nel social ci sono i seguenti utenti:')  
    for elem in self.visit.lista_utenti:
      print (elem)
    print ()
    for elem in self.grafo_visitato:
      print ('Tra gli utenti {0} c\'è una {1}.'.format (elem, self.grafo_visitato[elem]))

  # Metodo che trova tutte le relazioni indiciate
  def trova_tipo_relazione (self, tipo_relazione):
    for relazione in self.lista_relazioni:
      if relazione.tipo_relazione == tipo_relazione:
        print (relazione)
    
  def __str__ (self):
    return 'Num. Nodi: {0}\nNum. Relazioni: {1}'.format (self.num_nodi, self.num_relazioni)