
class pascalTriangle ():
  
  triangle = []		# E' la struttura dati che conterrà il trinagolo di Pascal (sarà una lista di liste)
  index = 0
  
  # Inizializzo l'iteratore passandogli il numero di righe del mio triangolo
  def __init__ (self, row):
    self.num_row = row
    
  def __iter__ (self):
    # Creo una lista di liste della dimensione che ho specificato prima
    for i in range (self.num_row + 1):
      self.triangle.append ([0])
    # Inizializzo alcune variabili utili all'iterazione
    self.index = 0	# index è la "riga" o il grado del triangolo di volta in volta
    self.value = 1	# value è la posizione all'interno di ogni riga del triangolo
    return self
    
  def __next__ (self):
    self.value = 1		# All'inizio di ogni interazione devo scpostare il cursore all'inizio di ogni riga
    if self.num_row < 0:	# Se il grado è minore di 0 non se ne fa niente...
      raise StopIteration
    if self.num_row == 0:	# Se il grado è uguale a 0 ho una sola riga con il solo valore 1
      if self.index <= self.num_row:
        self.triangle[self.index] = [1]
        self.index += 1
        return self.triangle
      else:
        raise StopIteration
    else:			# Se il grado è superiore a 0...
      if self.index <= self.num_row:
        self.triangle[self.index] = [1]	# La prima riga è sempre composta da un solo valore 1
        if self.index > 1:
          # A questo punto popolo ogni riga alla volta con tutti i valori necessari
          # calcolandoli a partire dai valori che ho già messo nella riga precedente
          while self.value < len (self.triangle[self.index - 1]):
            self.triangle[self.index].append (self.triangle[self.index - 1][self.value - 1] + self.triangle[self.index - 1][self.value])
            self.value += 1
          # Come ultima cosa pongo un 1 alla fine della riga
          self.triangle[self.index].append (1)
        elif self.index > 0:
          self.triangle[self.index].append (1)
          
        self.index += 1
        return self.triangle
      else:
        raise StopIteration
