import unittest, Pluralize

class testPluralize (unittest.TestCase):
  
  case_of_plural = [('horse', 'horses'), ('cow', 'cows'), ('candy', 'candies')]
  
  def test_is_pluralize_correct (self):
    for single, plural in self.case_of_plural:
      result = Pluralize.pluralize (single)
      self.assertEqual (result, plural)
      

if __name__ == '__main__':
  unittest.main ()