import unittest, Geography

def make_testGeography (classGeography):
  class testGeography (unittest.TestCase):
    
    a_list_of_state_and_neighbors = [
      ('Italia', ('Francia', 'Svizzera', 'Austria', 'Slovenia', 'Croazia')),
      ('Stati Uniti', ('Canada', 'Messico'))
      ]
    
    def test_neighbors (self):
      for state, neighbors in self.a_list_of_state_and_neighbors:
        result = classGeography().neighbors(state)
        self.assertEqual (result, neighbors)
  
  return testGeography
  
  
if __name__ == '__main__':
  test = make_testGeography (Geography.geography)
  unittest.main ()