from Person import person

class day_salary:
  def __get__ (self, instance, owner):
    return instance.pay_for_hour * 8
    
  def __set__ (self, instance, value):
    instance.pay_for_hour = value / 8
    
class week_salary:
  def __get__ (self, instance, owner):
    return instance.pay_for_hour * 8 * 5
    
  def __set__ (self, instance, value):
    instance.pay_for_hour = (value / 8) / 5
    
class month_salary:
  def __get__ (self, instance, owner):
    return instance.pay_for_hour * 8 * 5 * 4
    
  def __set__ (self, instance, value):
    instance.pay_for_hour = ((value / 8) / 5) / 4

class year_salary:
  def __get__ (self, instance, owner):
    return instance.pay_for_hour * 12 * 8 * 5 * 4
    
  def __set__ (self, instance, value):
    instance.pay_for_hour = (((value / 12) / 8) / 5) / 4
    
    
    

class worker (person):
  
  pay_for_hour = 0
  
  def __init__ (self, name, lastname, birthdate, pay_for_hour):
    person.__init__ (self, name, lastname, birthdate)
    self.pay_for_hour = pay_for_hour
    
  '''
  def day_salary_count (self):
    return self.pay_for_hour * 8
  
  def set_day_salary (self, value):
    self.pay_for_hour = value / 8
    
  def week_salary_count (self):
    return self.day_salary_count() * 5
  
  def set_week_salary (self, value):
    self.pay_for_hour = (value / 8) / 5
    
  def month_salary_count (self):
    return self.week_salary_count () * 4
 
  def set_month_salary (self, value):
    self.pay_for_hour = ((value / 8) / 5) / 4
  
  def year_salary_count (self):
    return self.month_salary_count () * 12
    
  def set_year_salary (self, value):
    self.pay_for_hour = (((value / 12) / 8) / 5) / 4
    
  day_salary = property (day_salary_count, set_day_salary, None, 'Day Salary')
  week_salary = property (week_salary_count, set_week_salary, None, 'Week Salary')
  month_salary = property (month_salary_count, set_month_salary, None, 'Month Salary')
  year_salary = property (year_salary_count, set_year_salary, None, 'Year Salary')
  '''
  
  day_salary = day_salary()
  month_salary = month_salary()
  week_salary = week_salary()
  year_salary = year_salary()
    
    
    
    
if __name__ == '__main__':
  allison = worker ('Allison', 'Stewart', '23/12/1986', 8.4)
  print ('{0}\'s hour salary is {1}$'.format (allison.name, allison.pay_for_hour))
  print ('{0}\'s day salary is {1}$'.format (allison.name, allison.day_salary))
  print ('{0}\'s week salary is {1}$'.format (allison.name, allison.week_salary))
  print ('{0}\'s month salary is {1}$'.format (allison.name, allison.month_salary))
  print ('{0}\'s year salary is {1}$'.format (allison.name, allison.year_salary))
  allison.week_salary = 50
  print ()
  print ('{0}\'s hour salary is {1}$'.format (allison.name, allison.pay_for_hour))
  print ('{0}\'s day salary is {1}$'.format (allison.name, allison.day_salary))
  print ('{0}\'s week salary is {1}$'.format (allison.name, allison.week_salary))
  print ('{0}\'s month salary is {1}$'.format (allison.name, allison.month_salary))
  print ('{0}\'s year salary is {1}$'.format (allison.name, allison.year_salary))
  print 
  