
def goldbach (n):
  
  first_n = n
  prime_part_of_n = [2]
  goldbach_list = list ()
  
  if n <= 2:
    print ('There isn\'t a Goldbach partition of {0}'.format (n))
  else:
    
    # Costruzione del vettore di numeri primi minori di n
    while n != 2:
      ris = n - 1
      if ris % 2 != 0:
        prime_part_of_n.append (ris)
      n -= 1

    # Pulizia del vettore di numeri primi minori di n
    for num1 in prime_part_of_n:
      for num2 in prime_part_of_n:
        if num1 != num2:
          if num1 % num2 == 0:
            if prime_part_of_n.count (num1) >= 1:
              del prime_part_of_n[prime_part_of_n.index(num1)]

    #print (prime_part_of_n)
    # Generazione delle partizioni di Goldbach
    for prime1 in prime_part_of_n:
      for prime2 in prime_part_of_n:
        if prime1 + prime2 == first_n:
          #print ('{0} + {1} = {2}'.format (prime1, prime2, first_n))
          goldbach_list.append([first_n, (prime1, prime2)])
        #else:
          #print ('The number {0} is already prime'.format (first_n))
    
    for elem in goldbach_list:
      elem[1] = sorted(elem[1])
    
    for elem1 in goldbach_list:
      for elem2 in goldbach_list:
        if elem1 == elem2:
          if goldbach_list.count(elem1) > 1:
            del goldbach_list[goldbach_list.index(elem1)]
      
    return goldbach_list

def goldbach_list (n, m):
  
  dict_of_goldbach = dict ()
  
  if n <= 2:
    n = 3
  
  for value in range (n, m+1):
    list_of_partition = goldbach (value)
    for partition in list_of_partition:
      if value in dict_of_goldbach:
        new_item = dict_of_goldbach[value]
        new_item.append (tuple (partition[1]))
        dict_of_goldbach[value] = new_item
        pass
      else:
        dict_of_goldbach[value] = [tuple (partition[1])]
      
  return dict_of_goldbach
  
if __name__ == '__main__':
  print ()
  goldbach_list_of_num = goldbach (39)
  for elem in goldbach_list_of_num:
      print ('{0} = {1} + {2}'.format (elem[0], elem[1][0], elem[1][1]))
  print ()
  dict_of_goldbach = goldbach_list (1, 12)
  for key, value in dict_of_goldbach.items():
    for partitions in value:
      print ('{0} = {1} + {2}'.format (key, partitions[0], partitions[1]))
  print ()