'''
A function anagram that checks if a string passed as a parameter 
is palindrome, a string is palindrome when the represented sentence 
can be read the same way in either directions in spite of spaces, 
punctual and letter cases, e.g., detartrated, "Do geese see God?", 
"Rise to vote, sir.".
'''

import re

def anagram (word):
  
  pattern = re.compile ('[?!.:,; ]')
  word = pattern.sub ('', word)
  
  if word.lower() == word[::-1].lower():
    return True
  else:
    return False