
class squareMatrix ():
  
  matrix = []
  
  def __init__ (self, size):
    
    if self.matrix != []:
      self.matrix = []
      
    self._row = []
    self.size = size
    
    for row in range (size):
      for column in range (size):
        if row == column :
          self._row.append (1)
        else:
          self._row.append (0)
      self.matrix.append (self._row)
      self._row = []
  
  # Funzione che somma i valori di ogni riga
  def sum_in_row (self):
    
    self.row_sum = []
    self.local_sum = 0
    
    for lenght in range (self.size):
      self.row_sum.append (0)
    
    for row in range (self.size):
      for column in range (self.size):
        self.local_sum += self.matrix[row][column]
      self.row_sum[row] = self.local_sum
      self.local_sum = 0

    return self.row_sum
  
  # Funzione che somma i valori di ogni colonna
  def sum_in_column (self):
    
    self.column_sum = []
    self.local_sum = 0
    
    for lenght in range (self.size):
      self.column_sum.append (0)
      
    for row in range (self.size):
      for column in range (self.size):
        self.local_sum += self.matrix[column][row]
      self.column_sum[row] = self.local_sum
      self.local_sum = 0
      
    return self.column_sum
    
  # Funzione che calcola la trasposta della matrice
  def transpose (self):
    
    self.temp_matrix = []
    self.temp_row = []
    for lenght in range (self.size):
      self.temp_matrix.append ([])
    
    for row in range (self.size):
      for column in range (self.size):
        self.temp_row.append (self.matrix[column][row])
      self.temp_matrix[row] = self.temp_row
      self.temp_row = []
    
    return self.temp_matrix
    
  # Funzione che calcola il determinante della matrice
  def determinant (self):
    self.determinant = 0
    
    if self.size == 2:
      self.determinant = (self.matrix[0][0] * self.matrix[1][1]) - (self.matrix[0][1] * self.matrix[1][0])
    else:
      self.determinant = 'Ci sto lavorando...'
      
    return self.determinant
    
  # Funzione che stampa la matrice a video
  def display (self, matrix):
    for row in matrix:
      for column in row:
        print (column, end=' ')
      print()
  

if __name__ == '__main__':
  new_matrix = squareMatrix (3)
  new_matrix.matrix[0][2] = 7
  new_matrix.display (new_matrix.matrix)
  print (new_matrix.sum_in_row())
  print (new_matrix.sum_in_column())
  new_matrix.display (new_matrix.transpose())
  print (new_matrix.determinant())
  
  new_matrix = squareMatrix(4)
  new_matrix.display (new_matrix.matrix)