import unittest, PascalTriangle

def make_testPascalTriangle (classPascalTriangle):
  class testPascalTriangle (unittest.TestCase):
    
    def setUp (self):
      self.known_triangle = [(grade, classPascalTriangle(grade)) for grade in range (1, 10)]
      
    def test_pascaleTriangle (self):
      self.temp = []
      self.count = 0
      for grade, triangle in self.known_triangle:
        iterator = classPascalTriangle(grade)
        for genPascalTriangle in triangle:
          self.temp.append (genPascalTriangle)
        for pascalTriangle in iterator:
          self.assertEqual (pascalTriangle, self.temp[self.count])
          self.count += 1
      self.count = 0
    
  return testPascalTriangle
  
if __name__ == '__main__':
  test = make_testPascalTriangle (PascalTriangle.pascalTriangle)
  unittest.main()