from Person import person
import datetime

class wizard (person):
  
  def __init__ (self, name, lastname, birthday):
    person.__init__ (self, name, lastname, birthday)
    
  def get_age (self):
    now = datetime.datetime.now()
    date = self.birthday.split('/')
    age = now.year - int (date[2])
    return age
  
  def set_age (self, value):
    date = self.birthday.split ('/')
    new_day = date[0]
    new_month = date[1]
    new_year = int (date[2]) + value
    self.birthday = '{0}/{1}/{2}'.format (new_day, new_month, new_year)
    
  age = property (get_age, set_age, None, 'Magical age')
  

if __name__ == '__main__':
  mago_merlino = wizard ('Merlino', '', '10/12/0870')
  print ('{0} is {1} years old.'.format (mago_merlino.name, mago_merlino.age))
  print ('But {0} makes a magic trik...'.format (mago_merlino.name))
  mago_merlino.age = 150
  print ('...and now {0} is {1} years old.'.format (mago_merlino.name, mago_merlino.age))
  print (mago_merlino.birthday)