from Person import person

class worker (person):
  
  pay_for_hour = 0
  
  def __init__ (self, name, lastname, birthdate, pay_for_hour):
    person.__init__ (self, name, lastname, birthdate)
    self.pay_for_hour = pay_for_hour
    
  def day_salary_count (self):
    return self.pay_for_hour * 8
  
  def set_day_salary (self, value):
    self.pay_for_hour = value / 8
    
  def week_salary_count (self):
    return self.day_salary_count() * 5
  
  def set_week_salary (self, value):
    self.pay_for_hour = (value / 8) / 5
    
  def month_salary_count (self):
    return self.week_salary_count () * 4
 
  def set_month_salary (self, value):
    self.pay_for_hour = ((value / 8) / 5) / 4
  
  def year_salary_count (self):
    return self.month_salary_count () * 12
    
  def set_year_salary (self, value):
    self.pay_for_hour = (((value / 12) / 8) / 5) / 4
    
  day_salary = property (day_salary_count, set_day_salary, None, 'Day Salary')
  week_salary = property (week_salary_count, set_week_salary, None, 'Week Salary')
  month_salary = property (month_salary_count, set_month_salary, None, 'Month Salary')
  year_salary = property (year_salary_count, set_year_salary, None, 'Year Salary')
    
    
    
    
if __name__ == '__main__':
  allison = worker ('Allison', 'Stewart', '23/12/1986', 8.4)
  print ('{0}\'s hour salary is {1}$'.format (allison.name, allison.pay_for_hour))
  print ('{0}\'s day salary is {1}$'.format (allison.name, allison.day_salary))
  print ('{0}\'s week salary is {1}$'.format (allison.name, allison.week_salary))
  print ('{0}\'s month salary is {1}$'.format (allison.name, allison.month_salary))
  print ('{0}\'s year salary is {1}$'.format (allison.name, allison.year_salary))
  allison.day_salary = 50.3
  print ('{0}\'s hour salary is {1}$'.format (allison.name, allison.pay_for_hour))
  print ('{0}\'s year salary is {1}$'.format (allison.name, allison.year_salary))
  print 
  