import os

# Funzione per aprire il file
def open_file (file_name):
  if os.path.isfile (file_name) == False:
    print ('\'{0}\': file non valido'.format (file_name))
  else:
    open_file = open (file_name, 'r')
    if open_file == False:
      raise IOError ('Impossibile aprire il file \'{0}\''.format (file_name))
    else:
      return open_file

# Funzione che crea un dizionario a partire dal flusso del file letto
def make_a_dict (a_dict, read_file):
  
  list_of_title = read_file.split('\n')
  for title in list_of_title:
    list_of_key = title.lower().split(' ')
    for key in list_of_key:
      if len (key) >= 3:
        a_dict.append ((key, list_of_title.index(title), title.split(' ')))
  for tuples in a_dict:
    if tuples[0] == 'the':
      del a_dict[a_dict.index(tuples)]
  return a_dict

# Funzione che stampa il contenuto del dizionario
def print_KeyWordInContext (a_dict):
  num = 0
  
  for sorted_words in sorted(a_dict):
    num_of_space = 40
    separator = ' '
    word = 0
    
    if len (sorted_words[2]) >= 2:
      if sorted_words[2][0].lower() != sorted_words[0]:
        while word != len (sorted_words[2]):
          if sorted_words[2][word].lower() != sorted_words[0]:
            if word < sorted_words[2].index(sorted_words[0].capitalize()):
              num_of_space -= len (sorted_words[2][word]) + 1
            else:
              if sorted_words[2].index(sorted_words[0].capitalize()) == len (sorted_words[2]):
                num_of_space += len (sorted_words[2][word]) + 1
          word += 1
      
    print ('{0}{1}{2}'.format (sorted_words[1] + 1, ' '*num_of_space, separator.join(sorted_words[2])))

    
if __name__ == '__main__':
  
  f_name = 'TitleInput.txt'
  f_dict = list()
  
  f_open = open_file (f_name)
  f_read = f_open.read()
  f_dict = make_a_dict (f_dict, f_read)
  '''
  for elem in f_dict:
    print (elem)
  '''
  print_KeyWordInContext (f_dict)
  